--
-- greenDirectCut
-- 
--
-- upsideDown 09.01.2014

greenDirectCut = {};

function greenDirectCut:newCutterUpdateTick(superFunc,dt)	
	if self:getIsActive() then		
		greenDirectCut:shiftMinGrowthState(self,-1);
		if g_currentMission.missionStats.difficulty == 3 then
			greenDirectCut:forceGreenForage(self,false);
		end;
	end;
	superFunc(self,dt);
	if self:getIsActive() then		
		greenDirectCut:shiftMinGrowthState(self,1);
		if g_currentMission.missionStats.difficulty == 3 then
			greenDirectCut:forceGreenForage(self,true);
		end;
	end;
end;

function greenDirectCut:shiftMinGrowthState(self,delta)
	for fruitType,entry in pairs(g_currentMission.fruits) do
		local outputFruitType = fruitType;
		if self.convertedFruits[fruitType] ~= nil then
			 outputFruitType = self.convertedFruits[fruitType];
		end;
		if outputFruitType == FruitUtil.FRUITTYPE_CHAFF then --its a chopper, and...
			--if entry.windrowId ~= nil and entry.windrowId ~= 0 then --we chop something with windrows, and...
				local desc = FruitUtil.fruitIndexToDesc[fruitType];
				if desc.name ~= "grass" then -- its not grass: go for it! :)
					desc.minHarvestingGrowthState = desc.minHarvestingGrowthState + delta;
					FruitUtil.fruitIndexToDesc[fruitType] = desc;
				end;
			--end;
		end;
	end;
end;

function greenDirectCut:forceGreenForage(self,reset)
	for fruitType,entry in pairs(g_currentMission.fruits) do
		local outputFruitType = fruitType;
		if self.convertedFruits[fruitType] ~= nil then
			 outputFruitType = self.convertedFruits[fruitType];
		end;
		if outputFruitType == FruitUtil.FRUITTYPE_CHAFF then --its a chopper, and...
			--if entry.windrowId ~= nil and entry.windrowId ~= 0 then --we chop something with windrows, and...
				local desc = FruitUtil.fruitIndexToDesc[fruitType];
				if desc.name ~= "grass" then -- its not grass: go for it! :)
					if reset then
						desc.maxHarvestingGrowthState = desc.origMaxHarvestingGrowthState;
					else
						desc.origMaxHarvestingGrowthState = desc.maxHarvestingGrowthState;
						desc.maxHarvestingGrowthState = desc.minHarvestingGrowthState;
					end;
					
					FruitUtil.fruitIndexToDesc[fruitType] = desc;
				end;
			--end;
		end;
	end;
end;

print("--- loading greenDirectCut mod V0.2 BETA--- (by upsidedown)")
Cutter.updateTick = Utils.overwrittenFunction(Cutter.updateTick,greenDirectCut.newCutterUpdateTick);